/************************************************
 **
 **    *** HAPPy P-code Interpriter ***
 **
 **             C
 **
 **          Copyright (c) H.Asano. 1992,1993.
 ************************************************/

#define EXTERN

#include <signal.h>
#include <process.h>
#include <io.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <float.h>
#include "version.h"
#include "hapai.h"

extern void callsp(void)  ;     /* call standard procedure            */
extern void T_get(fileinfo*, _store*, FILE*,char*); /* 1Ǎ      */

_store  store[Maxstore] ;       /* Lu                           */

_store  *sp        ;            /* X^bN|C^                   */
int pc   ;                      /* program counter                    */
int mp   ;                      /* begginning of a data segment       */
int ep   ;                      /* the maxmum extent of the stack     */
int np   ;                   /* top of the dynamically allocated area */

char p   ;                      /* p operand                          */
int  q   ;                      /* q operand                          */

boolean readlnflag = true ;     /* Nyinputreadln ^ */


static char *pcofname = "pcode.pco" ; /* P-codeIuWFNgt@C */
static char progname[33] ;      /* PascalvO                 */

static int fileno       ;       /* t@C                         */
static int     objsize  ;
static FILE    *pcofile ;
static boolean trace    ;       /* ߃g[XtO                 */
static boolean infor = false ;  /* -iIvV o       */

/******************************************/
/* prerr() : Run-timeG[bZ[Wo */
/******************************************/
void prerr(int errno,char *msg)
{
  int i ;

     fprintf(stderr,"\n*** [ADDR=%d] HAPPy Run-time error R%03d:\n   --  %s",
                    pc-1,errno,msg) ;
     fprintf(stderr," : ł؂ ***\n");

     for(i=0;i<fileno;i++) {            /* t@CN[Ys     */
      if((fi[i].mode == generation) &&  /* [hŃeLXg     */
         (fi[i].textfile) && (!fi[i].writelnflag)) /* ŌオsłȂ*/
        fputc('\n',fi[i].fp) ;          /* st           */
      fclose(fi[i].fp) ;                /* G[`FbN͂Ȃ     */
     }

     exit(1) ;                          /* ُI                   */
}

/****************************************/
/*   cntl_c(): cntl_cꂽ̏ */
/****************************************/
static void cntl_c(int sig,int subcode)
{
     prerr(152,"<CTRL-C>󂯕t");
}

/****************************************/
/*   real_err(): _O         */
/****************************************/
static void real_err(int sig, int subcode)
{
  char *type ;
  char buf[80] ;

     switch(subcode) {
      case FPE_INVALID        : type = "invalid";             break ;
      case FPE_OVERFLOW       : type = "overflow";            break ;
      case FPE_STACKOVERFLOW  : type = "stack overflow";      break ;
      case FPE_STACKUNDERFLOW : type = "stack underflow";     break ;
     }
     sprintf(buf,"Zňُ킪N(%s)",type) ;
     prerr(150,buf) ;
}

/***************************************/
/*   base(id) : ǏIԒn߂     */
/***************************************/
static int base(void)
{
  int ad ;
  int ld ;

     if(!p) return(mp) ;                /* ld0ȂmplԂ        */
     ad = mp ;
     ld = p  ;
     while((ld--))                       /* 0傫ԌJԂ      */
      ad = store[ad+1].va ;
     return(ad) ;
}

/************************ eP-code   ****************************/

/******************/
/*  ABI           */ /* abolute integers */
/******************/
static void ABI(void)
{
     (*sp).vi = labs((*sp).vi) ;
}

/******************/
/*  ABR           */ /* abolute reals */
/******************/
static void ABR(void)
{
     (*sp).vr = (float)fabs((double)(*sp).vr);
}

/******************/
/*  ADI           */ /* add integers */
/******************/
static void ADI(void)
{
     sp-- ;
     (*sp).vi += (*(sp+1)).vi ;
}

/******************/
/*  ADR           */ /* add reals */
/******************/
static void ADR(void)
{
     sp-- ;
     (*sp).vr += (*(sp+1)).vr ;
}

/******************/
/*  AND           */ /* logical and */
/******************/
static void AND(void)
{

     sp-- ;
     (*sp).vb = (*sp).vb && (*(sp+1)).vb ;
}

/******************/
/*  BAS           */  /* load base mark */
/******************/
static void BAS(void)
{
     (*++sp).va = base() ;
}

/******************/
/*  CHR           */  /* convert character */
/******************/
static void CHR(void)
{
    char buf[80] ;

     if((0L <= (*sp).vi) && ((*sp).vi <= 255L))
      (*sp).vc = (short)(*sp).vi ;
     else {
      sprintf(buf,"chr: ̒l(%ld)ɑΉ镶Ȃ",(*sp).vi);
      prerr(9,buf) ;
     }
}

/******************/
/*  CHK           */
/******************/
static void CHK(void)
{
  long i       ;
  long s       ;                        /* W                       */
  char buf[80] ;
  static struct {
           int  errno ;
           char *msg  ;
        } errtbl[] = {
    {  1,  "z̓Y̒l(%ld)͈͓(%ld`%ld)ɂȂ"},
    {  7,  "l̒l(%ld)͈͓(%ld`%ld)ɂȂ"},
    {  8,  "l̏Wl͈͓(%ld`%ld)ɂȂ"},
    { 17,  "read: obt@ϐ̒l(%d)͈͓(%ld`%ld)ɂȂ"},
    { 18,  "write: ̒l(%ld)͈͓(%ld`%ld)ɂȂ"},
    { 26,  "pack: ^̈̒l(%ld)͈͓(%ld`%ld)ɂȂ"},
    { 29,  "unpack: ^̈̒l(%ld)͈͓(%ld`%ld)ɂȂ"},
    { 31,  "unpack: ]ɋl߂Ȃz̓Y^z"},
    { 49,  ": EӒl(%ld)͈͓(%ld`%ld)ɂȂ"},
    { 50,  ": Wl͈͓(%ld`%ld)ɂȂ"},
    { 51,  "case: I̒l(%ld)ɍvI萔Ȃ"},
    { 52,  "for: l(%ld)͈͓(%ld`%ld)ɂȂ"},
    { 53,  "for: Il(%ld)͈͓(%ld`%ld)ɂȂ"},
    { 71,  "read: W^̃obt@ϐ̒l͈͓(%ld`%ld)ɂȂ"},
    { 72,  "write: W^̎̒l͈͓(%ld`%ld)ɂȂ"},
    {111,  "W\q̏̒l(%ld)HAPPy͈͓̐(%ld`%ld)ɂȂ"}
} ;

     switch(store[pc-1].vo.cdop) {
      case 97 :                         /* chks (W͈̔̓`FbN)  */
       s = 0 ;
       for(i=store[q-1].vi;i<=store[q].vi;i++)
        addset(s,i);
       s  = (~s & (*sp).vs) ;
       if(s != 0) {
        i = -1;
        while(errtbl[++i].errno != p) ;
        sprintf(buf,errtbl[i].msg,
                   store[q-1].vi,store[q].vi) ;
        prerr(p,buf) ;                  /* G[bZ[Wo       */
       }
       break ;

      default :                         /* chksȊÕ`FbN         */
       if(((*sp).vi < store[q-1].vi) ||
          ((*sp).vi > store[q].vi)) {
       i = -1 ;
       while(errtbl[++i].errno != p) ;
       sprintf(buf,errtbl[i].msg,
                    (*sp).vi, store[q-1].vi,store[q].vi) ;
       prerr(p,buf) ;                   /* G[bZ[Wo       */
      }
     }
}

/******************/
/*  CKA           */  /* Check Address */
/******************/
static void CKA(void)
{
     if((*sp).va == NilValue)
      prerr(3,"Ώەϐ̃|C^ϐ̒lnilł") ;

     if(!((np <= (*sp).va) && ((*sp).va < Maxstore)))
      prerr(4,"Ώەϐ̃|C^ϐ̒lsł") ;
}

/******************/
/*  CSP           */  /* call standard procedure */
/******************/
static void CSP(void)
{
     callsp() ;
}

/******************/
/*  CUI           */ /* Call User procedure Indirect */
/******************/
static void CUI(void)
{
  int calladr ;

     calladr = (*sp--).va ;             /* sJnAhX擾       */
     mp=(sp-store)-(p+4)  ;             /* 4mstƊ֌W               */
     store[mp+4].va = pc       ;        /* ߂Ԓn                   */
     pc = calladr              ;        /* jump                       */
}

/******************/
/*  CUP           */ /* Call User Procedure */
/******************/
static void CUP(void)
{
     mp=(sp-store)-(p+4) ;              /* 4mstƊ֌W*/
     store[mp+4].va = pc      ;         /* ߂Ԓn    */
     pc = q                   ;         /* jump        */
}

/******************/
/*  DEC           */
/******************/
static void DEC(void)
{
     switch(p) {
      case 1 : (*sp).vi -= q ;
               return ;
      case 6 : (*sp).vc -= q ;
               return ;
      case 3 : (*sp).vb -= q ;
               return ;
      case 0 : (*sp).va -= q ;
               return ;
      case 2 : (*sp).vr -= (float)q ;
               return ;
     }
}

/******************/
/*  DIF           */
/******************/
static void DIF(void)
{
     sp--;
     (*sp).vs  &= ((*sp).vs ^ (*(sp+1)).vs) ;
}

/******************/
/*  DVI           */
/******************/
static void DVI(void)
{
     if((*sp--).vi == 0) prerr(45,"divZq: 0Ŋ낤ƂĂ") ;
     (*sp).vi /= (*(sp+1)).vi ;
}

/******************/
/*  DVR           */
/******************/
static void DVR(void)
{
     if((*sp--).vr == (float)0.0)
      prerr(44,"/Zq: 0Ŋ낤ƂĂ") ;
     (*sp).vr /= (*(sp+1)).vr ;
}

/******************/
/*  EJP           */  /* Extra block Jump */
/******************/
static void EJP(void)
{
  int req ;

     req = base() ;
     while(mp != req) {                 /* X^bN̘g         */
      sp = store + mp-1;
      ep = store[mp+3].va;
      mp = store[mp+2].va;
     }
     pc = q;
}

/******************/
/*  ENT           */
/******************/
static void ENT(void)
{
     if(p==1) {                         /* p=1                        */
      if(q <= np-mp)                    /* mp+q <= np ̎            */
       sp = store + mp + q ;
      else prerr(122,"X^bNp̃sĂ") ;
     }
     else {                             /* p=2                        */
      if( q <= np-(sp-store))           /* sp+q <= ep ̎            */
       ep = (sp-store)+q ;              /* X^bN̘g`           */
      else prerr(122,"X^bNp̃sĂ") ;
     }
}

/******************/
/*  EQU           */
/******************/
static void EQU(void)
{

     sp-- ;

     switch(p) {
      case 1: (*sp).vb = (*sp).vi == (*(sp+1)).vi ;
              return;
      case 0: (*sp).vb = (*sp).va == (*(sp+1)).va ;
              return;
      case 6: (*sp).vb = (*sp).vc == (*(sp+1)).vc ;
              return;
      case 2: (*sp).vb = (*sp).vr == (*(sp+1)).vr ;
              return;
      case 3: (*sp).vb = (*sp).vb == (*(sp+1)).vb ;
              return;
      case 4: (*sp).vb = (*sp).vs == (*(sp+1)).vs ;
              return;
      case 5: (*sp).vb = (memcmp(&(store[(*sp).va].vc),
                               &(store[(*(sp+1)).va].vc),
                               q*sizeof(_store)) == 0);
     }
}

/******************/
/*  FJP           */
/******************/
static void FJP(void)
{
     if(! (*(sp--)).vb) pc = q;
}

/******************/
/*  FLO           */
/******************/
static void FLO(void)
{
     (*(sp-1)).vr = (float)(*(sp-1)).vi ;
}

/******************/
/*  FLT           */
/******************/
static void FLT(void)
{
     (*sp).vr = (float)(*sp).vi ;
}

/******************/
/*  GEQ           */
/******************/
static void GEQ(void)
{
     sp-- ;
     switch(p) {
      case 1: (*sp).vb = (*sp).vi >= (*(sp+1)).vi ;
              return;
      case 6: (*sp).vb = (*sp).vc >= (*(sp+1)).vc ;
              return;
      case 2: (*sp).vb = (*sp).vr >= (*(sp+1)).vr ;
              return;
      case 3: (*sp).vb = (*sp).vb >= (*(sp+1)).vb ;
              return;
      case 4: (*sp).vb =
              ((*(sp+1)).vs & ((*(sp+1)).vs ^ (*sp).vs))
                                ? false : true ;
              return;
      case 5: (*sp).vb = (memcmp(&(store[(*sp).va].vc),
                                     &(store[(*(sp+1)).va].vc),
                                     q*sizeof(_store)) >= 0);
     }
}

/******************/
/*  GRT           */
/******************/
static void GRT(void)
{
     sp-- ;
     switch(p) {
      case 1: (*sp).vb = (*sp).vi > (*(sp+1)).vi ;
              return;
      case 6: (*sp).vb = (*sp).vc > (*(sp+1)).vc ;
              return;
      case 2: (*sp).vb = (*sp).vr > (*(sp+1)).vr ;
              return;
      case 3: (*sp).vb = (*sp).vb > (*(sp+1)).vb ;
              return;
      case 5: (*sp).vb = (memcmp(&(store[(*sp).va].vc),
                                     &(store[(*(sp+1)).va].vc),
                                     q*sizeof(_store)) > 0);
     }
}

/******************/
/*  INC           */
/******************/
static void INC(void)
{
     switch(p) {
      case 1 : (*sp).vi += q ;
               return ;
      case 6 : (*sp).vc += q ;
               return ;
      case 3 : (*sp).vb += q ;
               return ;
      case 0 : (*sp).va += q ;
               return ;
      case 2 : (*sp).vr += (float)q ;
               return ;
     }
}

/******************/
/*  IND           */
/******************/
static void IND(void)
{
     (*sp)=store[(*sp).va+q] ;
}

/******************/
/*  INN           */
/******************/
static void INN(void)
{
  integer i;

     i=(*(--sp)).vi ;
     (*sp).vb = (boolean)inset((*(sp+1)).vs,i) ;
}

/******************/
/*  INT           */
/******************/
static void INT(void)
{
     sp--;
     (*sp).vs &= (*(sp+1)).vs  ;
}

/******************/
/*  IOR           */ /* logical inclusive or */
/******************/
static void IOR(void)
{
     sp-- ;
     (*sp).vb = (*sp).vb || (*(sp+1)).vb ;
}

/******************/
/*  IXA           */
/******************/
static void IXA(void)
{
     (*sp).vi -= store[q-1].vi ;       /* l               */
     (*sp).va += (int)store[q].vi*(int)(*(sp--)).vi ;
}

/******************/
/*  LAO           */  /* load base-level address */
/******************/
static void LAO(void)
{
     (*(++sp)).va = q ;
}

/******************/
/*  LAP           */  /* Load Address Procedure */
/******************/
static void LAP(void)
{
     (*(++sp)).va = q ;
}

/******************/
/*  LCA           */
/******************/
static void LCA(void)
{
     (*(++sp)).va = q ;
}

/******************/
/*  LCI           */  /* load constant integer */
/******************/
static void LCI(void)
{
     (*(++sp)).vi = store[q].vi ;
}

/******************/
/*  LDA           */  /* load level p address */
/******************/
static void LDA(void)
{
     (*(++sp)).va = base()+q ;
}

/******************/
/*  LDC           */  /* load constant */
/******************/
static void LDC(void)
{
     sp++ ;
     switch(p) {
      case 1 : (*sp).vi = q;           /* integer */
               return ;
      case 6 : (*sp).vc = q;           /* char    */
               return ;
      case 3 : (*sp).vb = q;           /* boolean */
               return ;
      case 2 : (*sp).vr = store[q].vr; /* real    */
               return ;
      case 4 : (*sp).vs = store[q].vs ;/* set     */
               return ;
      case 0 : (*sp).va = NilValue ;   /* nil     */
                    /* programmer  łȂl   */
     }
}

/******************/
/*  LDO           */  /* load contents of base-level address */
/******************/
static void LDO(void)
{
     (*(++sp))=store[q] ;
}

/******************/
/*  LDOC          */  /* load char of base-level address */
/******************/
     /* inputobt@̒l܂ĂȂ̂߂
        ʂȏKvȂ̂ŁȀ܂ */
static void LDOC(void)
{
     if((q == fi[0].fileadr) && readlnflag) {
      T_get(fi,store+fi[0].fileadr,stdin,"get");
      readlnflag = false ;
     }

     *(++sp) = store[q] ;
}

/******************/
/*  LEQ           */
/******************/
static void LEQ(void)
{
     sp-- ;
     switch(p) {
      case 1: (*sp).vb = (*sp).vi <= (*(sp+1)).vi ;
              return;
      case 6: (*sp).vb = (*sp).vc <= (*(sp+1)).vc ;
              return;
      case 2: (*sp).vb = (*sp).vr <= (*(sp+1)).vr ;
              return;
      case 3: (*sp).vb = (*sp).vb <= (*(sp+1)).vb ;
              return;
      case 4: (*sp).vb =
              ((*sp).vs & ((*sp).vs ^ (*(sp+1)).vs))
                            ? false : true ;
              return;
      case 5: (*sp).vb = (memcmp(&(store[(*sp).va].vc),
                                     &(store[(*(sp+1)).va].vc),
                                     q*sizeof(_store)) <= 0);
     }
}

/******************/
/*  LES           */
/******************/
static void LES(void)
{
     sp-- ;
     switch(p) {
      case 1: (*sp).vb = (*sp).vi < (*(sp+1)).vi ;
              return;
      case 6: (*sp).vb = (*sp).vc < (*(sp+1)).vc ;
              return;
      case 2: (*sp).vb = (*sp).vr < (*(sp+1)).vr ;
              return;
      case 3: (*sp).vb = (*sp).vb < (*(sp+1)).vb ;
              return;
      case 5: (*sp).vb = (memcmp(&(store[(*sp).va].vc),
                                     &(store[(*(sp+1)).va].vc),
                                     q*sizeof(_store)) < 0);
     }
}

/******************/
/*  LOD           */  /* load contents of address at level p */
/******************/
static void LOD(void)
{

     *(++sp)=store[base()+q];
}

/******************/
/*  MMS           */  /* Make Multiple Set */
/******************/
static void MMS(void)
{
  long    s = 0;
  integer i ;

     sp--    ;
     for(i=(*sp).vi;i<=(*(sp+1)).vi;i++)
      addset(s,i);
     (*sp).vs = s;
}

/******************/
/*  MOD           */
/******************/
static void MOD(void)
{
     if((*sp--).vi <= 0)
      prerr(46,"modZq: EӒl0܂͕ł") ;
     (*sp).vi %= (*(sp+1)).vi ;
}

/******************/
/*  MOV           */
/******************/
static void MOV(void)
{
     if(p==1)
      memcpy(&store[(*(sp-1)).va],
             &store[(*sp).va],  q*sizeof(_store)) ;
     else                               /* pack,unpack̎g        */
      memcpy(&store[(*sp).va],
             &store[(*(sp-1)).va],  q*sizeof(_store)) ;

     sp-=2 ;

}

/******************/
/*  MPI           */
/******************/
static void MPI(void)
{
     sp--;
     (*sp).vi *= (*(sp+1)).vi ;
}

/******************/
/*  MPR           */
/******************/
static void MPR(void)
{
     sp--;
     (*sp).vr *= (*(sp+1)).vr ;
}

/******************/
/*  MSI           */ /* Mark Stack Indirect */
/******************/
static void MSI(void)
{
     (*(sp+2)).va = (unsigned char)(*(sp--)).va ;     /* Í    */
     (*(sp+3)).va = mp  ;                             /*     */
     (*(sp+4)).va = ep  ;                             /* ep    */
     sp += 5            ;
}

/******************/
/*  MST           */ /* Mark STack */
/******************/
static void MST(void)
{
     (*(sp+2)).va = base()  ;      /* Í */
     (*(sp+3)).va = mp      ;      /*  */
     (*(sp+4)).va = ep      ;      /* ep */
     sp += 5                ;
}

/******************/
/*  NEQ           */
/******************/
static void NEQ(void)
{
     sp-- ;
     switch(p) {
      case 1: (*sp).vb = (*sp).vi != (*(sp+1)).vi ;
              return;
      case 0: (*sp).vb = (*sp).va != (*(sp+1)).va ;
              return;
      case 6: (*sp).vb = (*sp).vc != (*(sp+1)).vc ;
              return;
      case 2: (*sp).vb = (*sp).vr != (*(sp+1)).vr ;
              return;
      case 3: (*sp).vb = (*sp).vb != (*(sp+1)).vb ;
              return;
      case 4: (*sp).vb = (*sp).vs != (*(sp+1)).vs ;
               return;
      case 5: (*sp).vb = (memcmp(&(store[(*sp).va].vc),
                                     &(store[(*(sp+1)).va].vc),
                                     q*sizeof(_store)) != 0);
     }
}

/******************/
/*  NGI           */
/******************/
static void NGI(void)
{
     (*sp).vi = - (*sp).vi ;
}

/******************/
/*  NGR           */
/******************/
static void NGR(void)
{
     (*sp).vr = - (*sp).vr ;
}

/******************/
/*  NOP           */  /* no operation */  /* ݎgĂ܂ */
/******************/
static void NOP(void)
{
}

/******************/
/*  NOT           */
/******************/
static void NOT(void)
{
     (*sp).vb = ! (*sp).vb ;
}

/******************/
/*  ODD           */
/******************/
static void ODD(void)
{
     (*sp).vb = (((*sp).vi % 2) != 0) ;
}

/******************/
/*  ORD           */  /* ORdinary */
/******************/
static void ORD(void)
{
     if(p == 3)                        /* ordb                        */
      (*sp).vi = (integer)(*sp).vb ;
     else                              /* ordc                        */
      (*sp).vi = (integer)(*sp).vc ;
}

/******************/
/*  RET           */
/******************/
static void RET(void)
{
     if(p==0) sp = store + mp -1 ;      /* retp:p=0  p<>0͈ȉ̖ */
     else     sp = store + mp    ;      /* reti,retr,retc,retb,rets   */
     pc  = store[mp+4].va ;             /* pc A                    */
     ep  = store[mp+3].va ;             /* ep A                    */
     mp  = store[mp+2].va ;             /* mp A                    */
}

/******************/
/*  ROU           */  /* round */
/******************/
static void ROU(void)
{
     (*sp).vi = (integer)floor((double)((*sp).vr + 0.5)) ;
}

/******************/
/*  SBI           */ /* subtruct integers */
/******************/
static void SBI(void)
{
     sp-- ;
     (*sp).vi -= (*(sp+1)).vi ;
}

/******************/
/*  SBR           */ /* subtruct reals */
/******************/
static void SBR(void)
{
     sp-- ;
     (*sp).vr -= (*(sp+1)).vr ;
}

/******************/
/*  SGS           */
/******************/
static void SGS(void)
{
  long s = 0;

     addset(s,(*sp).vi);
     (*sp).vs = s;
}

/******************/
/*  SQI           */
/******************/
static void SQI(void)
{
     (*sp).vi *= (*sp).vi ;
}

/******************/
/*  SQR           */
/******************/
static void SQR(void)
{
     (*sp).vr *= (*sp).vr ;
}

/******************/
/*  SRO           */  /* store at base-level address */
/******************/
static void SRO(void)
{
     store[q] = *(sp--) ;
}

/******************/
/*  STO           */
/******************/
static void STO(void)
{
     store[(*(sp-1)).va] = *sp ;
     sp-=2 ;
}

/******************/
/*  STP           */  /* stop */
/******************/
static void STP(void)
{
  int i ;

     for(i=0;i<fileno;i++) {            /* t@CN[Ys     */
      if((fi[i].mode == generation) &&  /* [hŃeLXg     */
         (fi[i].textfile) && (!fi[i].writelnflag)) /* ŌオsłȂ*/
        fputc('\n',fi[i].fp) ;          /* st           */
      fclose(fi[i].fp) ;                /* G[`FbN͂Ȃ     */
     }
     exit(0) ;
}

/******************/
/*  STR           */  /* store contents at address at level p */
/******************/
static void STR(void)
{
     store[base()+q] = *sp-- ;
}

/******************/
/*  TRA           */  /* trace of execuction */
/******************/
static void TRA(void)
{
     trace = (p==1) ;                   /* tra 1 ̎ g[XON      */
}

/******************/
/*  TRC           */  /* truncate */
/******************/
static void TRC(void)
{
     (*sp).vi = (integer)(*sp).vr ;
}

/******************/
/*  UDF           */  /* UnDeFined instruction */
/******************/
static void UDF(void)
{
     prerr(142,"`߂s悤Ƃ") ;
}

/******************/
/*  UJC           */
/******************/
static void UJC(void)
{
     prerr(51,"case: I̒lɍvI萔Ȃ") ;
}

/******************/
/*  UJP           */
/******************/
static void UJP(void)
{
     pc = q;
}

/******************/
/*  UNI           */
/******************/
static void UNI(void)
{
     sp--   ;
     (*sp).vs |= (*(sp+1)).vs  ;
}

/******************/
/*  XJP           */
/******************/
static void XJP(void)
{
     pc = (int)(*sp--).vi+q;
}


/**********************************************************************/
/*                      P-code    Gg\                    */
/**********************************************************************/

static struct entry {
       void (*func)(void) ;
} pcd[] = {
           /*         xx0  xx1  xx2  xx3  xx4  xx5  xx6  xx7  xx8  xx9   */

           /*00x*/    LOD, LDO, STR, SRO, LDA, LAO, STO, LDC, BAS, IND,
           /*01x*/    INC, MST, CUP, ENT, RET, CSP, IXA, EQU, NEQ, GEQ,
           /*02x*/    GRT, LEQ, LES, UJP, FJP, XJP, CHK, LAP, ADI, ADR,
           /*03x*/    SBI, SBR, SGS, FLT, FLO, TRC, NGI, NGR, SQI, SQR,
           /*04x*/    ABI, ABR, NOT, AND, IOR, DIF, INT, UNI, INN, MOD,
           /*05x*/    ODD, MPI, MPR, DVI, DVR, MOV, LCA, DEC, STP, ORD,
           /*06x*/    CHR, UJC, MMS, MSI, CUI, EJP, LCI, CKA, TRA, ROU,
           /*07x*/    STR, STR, STR, STR, STR, SRO, SRO, SRO, SRO, SRO,
           /*08x*/    STO, STO, STO, STO, STO, IND, IND, IND, IND, IND,
           /*09x*/    UDF, UDF, UDF, UDF, UDF, UDF, CHK, CHK, CHK, CHK,
           /*10x*/    UDF, UDF, UDF, UDF, UDF, LDO, LDO, LDO, LDO, LDOC,
           /*11x*/    UDF, UDF, UDF, UDF, UDF, LOD, LOD, LOD, LOD, LOD,
           /*12x*/    UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF,
           /*13x*/    UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF,
           /*14x*/    UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF,
           /*15x*/    UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF,
           /*16x*/    UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF,
           /*17x*/    UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF,
           /*18x*/    UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF,
           /*19x*/    UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF,
           /*20x*/    UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF,
           /*21x*/    UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF,
           /*22x*/    UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF,
           /*23x*/    UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF,
           /*24x*/    UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF, UDF,
           /*25x*/    UDF, UDF, UDF, UDF, UDF, UDF
         };

/***************************************/
/* information() : o͏ */
/***************************************/
static void information(void)
{
   fprintf(stderr,
    "HAPPy P-code Interpriter Version %s  Copyright (c) H.Asano 1992,1993\n",
                                      version) ;
 fputs("\n  HAPPy is the H.Asano Pascal Processing system. (^_^)\n",
             stderr);
 fputs(
  "\n  HAPPyISO7185Ki0ɂقڏMS-DOSėpPascalnłB\n",
           stderr) ;
 fputs("  HAPPy̕ʁEĔzt͎RłB\n", stderr) ;

fputs("\n  piނpcނōP-code޼ު(pcode.pco)s܂B\n",
         stderr);
}

/*****************************************/
/*  inputfilename() : t@C͏ */
/*****************************************/
static void inputfilename(void)
{
  int i,j ;
  int  ch ;

     fputs("*HAPPy: t@C( ",stderr) ;
     for(i=2;i<fileno;i++)  fprintf(stderr,"%s ",fi[i].filename) ;
     fputs(")̎t@C͂ĉ\n",stderr);

     for(i=2;i<fileno;i++) {
      fi[i].textfile = false      ;     /* Ƃ肠eLXgłȂ   */
                                        /* ƂĂ                 */
      fprintf(stderr," %s : ",fi[i].filename) ;
      while(((ch=getc(stdin)) == ' ') || (ch == '\t'));
                                        /* ,^u̓ǂݔ΂      */
      j = 0 ;
      while(ch != '\n') {
       fi[i].rfname[j++] = (char)ch ;
       if(j == MaxRFlen) break ;
       ch = getc(stdin) ;
      }  ;
      fi[i].rfname[j] = '\0' ;
     }

     fprintf(stderr,"\n*HAPPy: vO(%s)s܂\n",progname);
}

/***************************************/
/*      init() :  ݒ菈         */
/***************************************/
static void init(int argc, char **argv)
{
  int i,j ;
  char ch ;
  int headerlen       ;                 /* wb_̒           */
  char compversion[6] ;                 /* RpCo[Wԍ   */

     for(i=2;i<=argc;i++) {             /* IvV̏           */
      if(**++argv == '-') {
       for(j=1;*(*argv+j)!='\0';j++) {
        switch(tolower(*(*argv+j))) {   /* 啶̎͏ɕϊ   */
         case 'i' : infor = true   ;    /* information option         */
                    break          ;
         case 't' : trace = true   ;    /* trace option               */
                    break          ;
        }
       }
      }
     }

     if(infor) information() ;          /* o            */

  /**** input,outputt@C̃t@Cݒ肷
          ́̕AbIłAύX\ł ****/

     strcpy(fi[0].filename,"input")  ;
     fi[0].fileadr  = 5              ;  /* 5inputAhX           */
     fi[0].filesize = 1              ;
     strcpy(fi[0].rfname,"W") ;
     fi[0].fp       = stdin          ;  /* W                   */
     fi[0].mode     = inspection     ;  /* [h                 */
     fi[0].textfile = true           ;  /* eLXgt@C           */

     strcpy(fi[1].filename,"output") ;
     fi[1].fileadr  = 6              ;  /* 6outputAhX          */
     fi[1].filesize = 1              ;
     strcpy(fi[1].rfname,"Wo") ;
     fi[1].fp       = stdout         ;  /* Wo                   */
     fi[1].mode     = generation     ;  /* [h                 */
     fi[1].textfile = true           ;  /* eLXgt@C           */
     fi[1].writelnflag = true        ;

     fileno = 2 ;


     pcofile = fopen(pcofname,"rb");
     if(pcofile==NULL) {
      fprintf(stderr,
"I001: P-codeIuWFNgt@C(%s)Ȃ\n",pcofname);
      exit(2);
     }
     objsize = (int)filelength(fileno(pcofile));
     i = 0 ;
     do {                               /* o[Wԍǂ       */
      ch = (char)fgetc(pcofile) ;
      if(feof(pcofile)) {          /* rŃt@CIĂ܂*/
       fprintf(stderr,
"I002: P-codeIuWFNgt@C(%s)sł",pcofname) ;
       exit(2) ;
      }
     } while((compversion[i++]=ch) != '\0') ;
     headerlen = i ;
     if(strcmp(compversion,version)) {
      fprintf(stderr,
"I003: RpC(Version %s)ƃC^v^(Version %s)̃o[WႤ\n",
                    compversion, version) ;

      exit(2);
     }
     i = 0 ;
     do {                               /* vOǂ         */
      progname[i] = (char)fgetc(pcofile) ;
     } while(progname[i++] != '\0') ;
     headerlen += i ;

     while((fi[fileno].fileadr = getw(pcofile)) != -1) {
      headerlen += sizeof(int) ;
      fi[fileno].filesize = getw(pcofile) ; /* obt@ϐ̑傫   */
      headerlen += sizeof(int) ;
      i = 0 ;
      do {                               /* t@Cǂ          */
       fi[fileno].filename[i] = (char)fgetc(pcofile) ;
      } while(fi[fileno].filename[i++] != '\0') ;
      fi[fileno].mode = undefined ;     /* t@C[h͕s       */

      headerlen += i ;
      fileno++ ;
     }
     if(feof(pcofile)) {                /* R[hȂꍇ       */
      fprintf(stderr,
"I002: P-codeIuWFNgt@C(%s)sł",pcofname) ;
      exit(2) ;
     }

     headerlen += sizeof(int) ;
     objsize = objsize - headerlen ;
     fread((char*)store,objsize,1,pcofile) ; /* P-codeIuWFNgǂ*/
     objsize /= sizeof(_store) ;

     if(infor) {
      fprintf(stderr,"\n * Program name = %s\n",progname) ;
      fprintf(stderr," * Total memory = %5d words\n",Maxstore) ;
      fprintf(stderr," * Object size  = %5d words\n",objsize)  ;
      fprintf(stderr," * stack/heap   = %5d words\n\n",Maxstore-objsize) ;
     }

     if(fileno>2) inputfilename() ;

     signal(SIGINT,cntl_c) ;            /* CTRL-CVOio^        */
     signal(SIGFPE,real_err) ;          /* ZVOio^      */
}

/*******************************************/
/*  pitpr() : P-codeC^v^C */
/*******************************************/
void main(int argc,char **argv)
{
  register _store *adrinst ;
  int i ;

     init(argc,argv) ;

     pc = 0          ;
     mp = objsize    ;
     np = Maxstore   ;
     ep = objsize+5  ;
     sp = store+objsize-1  ;       /* X^bN|C^̏ݒ */


     for(i=0;i<fileno;i++) {
      fi[i].fileadr += objsize ;        /* t@CAhX̏C     */
      fi[i].filebuf =  store + fi[i].fileadr ; /* obt@ϐAhX*/
     }

loop :
      adrinst = store + pc++ ;
      p  = (*adrinst).vo.cdp  ;
      q  = (*adrinst).vo.cdq  ;

      if(trace)                         /* g[XIvVL     */
       printf("%4d[%3d %1d %6d] mp=%4d np=%4d ep=%4d stack[%4d]=%08lxH\n",
         pc-1,(*adrinst).vo.cdop,p,q, mp,np,ep,sp-store,(*sp).vi);

      pcd[(*adrinst).vo.cdop].func() ;  /* opɑΉ߂s     */

     goto loop;
}
